require "greek/i18n/version"
require "yaml"
require "i18n"

I18n.enforce_available_locales = false

module Greek
  module I18n
    TRANSLITERATIONS = %w[greeklish atono ancient_greeklish].freeze
    LOCALES_DIR = "../../../locales".freeze
    def self.setup
      TRANSLITERATIONS.each do |transliteration|
        locales_location = File.expand_path(LOCALES_DIR, __FILE__)
        locale_file = "#{locales_location}/#{transliteration}.yml"
        locale_obj = YAML.load_file(locale_file)
        locale = locale_obj[transliteration]["i18n"]
        ::I18n.backend.store_translations(
          transliteration.to_sym,
          i18n: locale
        )
      end
    end

    def self.greeklish(line)
      ::I18n.transliterate(line, locale: :greeklish)
    end

    def self.ancient_greeklish(line)
      ::I18n.transliterate(line, locale: :ancient_greeklish)
    end

    def self.atono(line)
      ::I18n.transliterate(line, locale: :atono)
    end
  end
end
Greek::I18n.setup
